package com.tencent.supersonic.headless.server.persistence.dataobject;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

@Data
@TableName("s2_database")
public class DatabaseDO {
    /** */
    @TableId(type = IdType.AUTO)
    private Long id;

    /** 名称 */
    private String name;

    /** 描述 */
    private String description;

    /** */
    private String version;

    /** 类型 mysql,clickhouse,tdw */
    private String type;

    /** 创建时间 */
    private Date createdAt;

    /** 创建人 */
    private String createdBy;

    /** 更新时间 */
    private Date updatedAt;

    /** 更新人 */
    private String updatedBy;

    /** */
    private String admin;

    /** */
    private String viewer;

    private Integer isOpen = 0;

    /** 配置信息 */
    private String config;

    /** @return id */
    public Long getId() {
        return id;
    }

    /** @param id */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * 名称
     *
     * @return name 名称
     */
    public String getName() {
        return name;
    }

    /**
     * 名称
     *
     * @param name 名称
     */
    public void setName(String name) {
        this.name = name == null ? null : name.trim();
    }

    /**
     * 描述
     *
     * @return description 描述
     */
    public String getDescription() {
        return description;
    }

    /**
     * 描述
     *
     * @param description 描述
     */
    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }

    /** @return version */
    public String getVersion() {
        return version;
    }

    /** @param version */
    public void setVersion(String version) {
        this.version = version == null ? null : version.trim();
    }

    /**
     * 类型 mysql,clickhouse,tdw
     *
     * @return type 类型 mysql,clickhouse,tdw
     */
    public String getType() {
        return type;
    }

    /**
     * 类型 mysql,clickhouse,tdw
     *
     * @param type 类型 mysql,clickhouse,tdw
     */
    public void setType(String type) {
        this.type = type == null ? null : type.trim();
    }

    /**
     * 创建时间
     *
     * @return created_at 创建时间
     */
    public Date getCreatedAt() {
        return createdAt;
    }

    /**
     * 创建时间
     *
     * @param createdAt 创建时间
     */
    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    /**
     * 创建人
     *
     * @return created_by 创建人
     */
    public String getCreatedBy() {
        return createdBy;
    }

    /**
     * 创建人
     *
     * @param createdBy 创建人
     */
    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy == null ? null : createdBy.trim();
    }

    /**
     * 更新时间
     *
     * @return updated_at 更新时间
     */
    public Date getUpdatedAt() {
        return updatedAt;
    }

    /**
     * 更新时间
     *
     * @param updatedAt 更新时间
     */
    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    /**
     * 更新人
     *
     * @return updated_by 更新人
     */
    public String getUpdatedBy() {
        return updatedBy;
    }

    /**
     * 更新人
     *
     * @param updatedBy 更新人
     */
    public void setUpdatedBy(String updatedBy) {
        this.updatedBy = updatedBy == null ? null : updatedBy.trim();
    }

    /** @return admin */
    public String getAdmin() {
        return admin;
    }

    /** @param admin */
    public void setAdmin(String admin) {
        this.admin = admin == null ? null : admin.trim();
    }

    /** @return viewer */
    public String getViewer() {
        return viewer;
    }

    /** @param viewer */
    public void setViewer(String viewer) {
        this.viewer = viewer == null ? null : viewer.trim();
    }

    /**
     * 配置信息
     *
     * @return config 配置信息
     */
    public String getConfig() {
        return config;
    }

    /**
     * 配置信息
     *
     * @param config 配置信息
     */
    public void setConfig(String config) {
        this.config = config == null ? null : config.trim();
    }
}
